String repositoryGenerator(String name) => '''
import 'package:easy/easy.dart';
import 'package:http/http.dart' as http;
import 'dart:io';
import 'dart:convert';

const BASE_URL = "https://jsonplaceholder.typicode.com/posts/";

class ${name}Repository extends Disposable {

  final HttpInstance http;

  PostRepository(this.http);

 
  Future<List<PostModel>> getPosts() async {
    try {
      var response = await http.client.get(
        BASE_URL,
      );
      return (json.decode(response.body) as List)
          .map((item) => PostModel.fromJson(item))
          .toList();
    } on SocketException catch (e) {
      throw (e.message);
    }
  }

   Future<List<PostModel>> setPosts() async {
    try {
      
      var response = await http.client.post(
        Constants.posts, 
      );
      return (json.decode(response.body) as List)
          .map((item) => PostModel.fromJson(item))
          .toList();
    } on SocketException catch (e) {
      throw (e.message);
    }
  }

  //dispose will be called automatically
  @override
  void dispose() {
    HttpInstance().dispose();
  }

}

  ''';
